VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Prasad's Tree to Tree Drag & Drop Programme."
   ClientHeight    =   5205
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6975
   LinkTopic       =   "Form1"
   ScaleHeight     =   5205
   ScaleWidth      =   6975
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "About Me"
      Height          =   405
      Left            =   2940
      MouseIcon       =   "Form1.frx":0000
      MousePointer    =   99  'Custom
      TabIndex        =   9
      Top             =   4740
      Width           =   1095
   End
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   6270
      Top             =   1050
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   4
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":0152
            Key             =   "selimg"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":05A6
            Key             =   "defaultimg"
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":08C2
            Key             =   "srcimg"
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":0D16
            Key             =   "dragimg"
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Set Root for Drop"
      Height          =   285
      Left            =   4650
      TabIndex        =   3
      Top             =   1080
      Width           =   1425
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Clear"
      Height          =   285
      Left            =   3810
      TabIndex        =   2
      Top             =   1080
      Width           =   795
   End
   Begin MSComctlLib.TreeView TreeView2 
      Height          =   2955
      Left            =   3780
      TabIndex        =   1
      Top             =   1680
      Width           =   2985
      _ExtentX        =   5265
      _ExtentY        =   5212
      _Version        =   393217
      LineStyle       =   1
      Style           =   7
      ImageList       =   "ImageList1"
      Appearance      =   1
   End
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   2955
      Left            =   180
      TabIndex        =   0
      Top             =   1650
      Width           =   3045
      _ExtentX        =   5371
      _ExtentY        =   5212
      _Version        =   393217
      LineStyle       =   1
      Style           =   7
      ImageList       =   "ImageList1"
      Appearance      =   1
   End
   Begin VB.Label Label5 
      BackColor       =   &H80000001&
      Caption         =   $"Form1.frx":15F2
      ForeColor       =   &H8000000E&
      Height          =   615
      Left            =   30
      TabIndex        =   8
      Top             =   30
      Width           =   6975
   End
   Begin VB.Label Label4 
      Caption         =   "Target Tree"
      Height          =   255
      Left            =   3840
      TabIndex        =   7
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Source Tree"
      Height          =   285
      Left            =   150
      TabIndex        =   6
      Top             =   1350
      Width           =   1785
   End
   Begin VB.Label Label2 
      BackColor       =   &H8000000E&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000D&
      Height          =   255
      Left            =   4440
      TabIndex        =   5
      Top             =   780
      Width           =   2565
   End
   Begin VB.Label Label1 
      Caption         =   "Selected:"
      Height          =   255
      Left            =   3780
      TabIndex        =   4
      Top             =   780
      Width           =   675
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim SelNode As Node
Dim Draging As Boolean

Private Sub Command1_Click()
    Me.TreeView2.Nodes.Clear
End Sub

Private Sub Command2_Click()
    Set Me.TreeView2.SelectedItem = Nothing
    Me.Label2.Caption = ""
End Sub

Private Sub Command3_Click()
Form2.Show vbModal
End Sub

Private Sub Form_Load()
    Call BuildTree(Me.TreeView1)
End Sub

Public Sub BuildTree(tvw As TreeView)

Dim nd As Node
Dim pkey As String
Dim key As String
Dim text As String

tvw.DragIcon = Me.ImageList1.ListImages.Item("dragimg").Picture

For i = 1 To 5
    key = "a" & i
    text = key
    Set nd = tvw.Nodes.Add(, , key, text, "srcimg")
Next


For i = 1 To 5
    pkey = "a" & i
    key = "b" & i
    text = key
    Set nd = tvw.Nodes.Add(pkey, tvwChild, key, text, "srcimg")
Next


For i = 1 To 5
    pkey = "b" & i
    key = "c" & i
    text = key
    Set nd = tvw.Nodes.Add(pkey, tvwChild, key, text, "srcimg")
Next


End Sub

Private Sub TreeView1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   Set SelNode = TreeView1.SelectedItem ' Set the item being dragged.
End Sub


Private Sub TreeView1_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)

   If Button = vbLeftButton Then ' Signal a Drag operation.
      Draging = True ' Set the flag to true.
      ' Set the drag icon with the CreateDragImage method.
      
      TreeView1.Drag vbBeginDrag ' Drag operation.
   End If
End Sub


Private Sub TreeView1_DragOver(Source As Control, x As Single, y As Single, State As Integer)
   If Draging = True Then
      ' Set DropHighlight to the mouse's coordinates.
      Set TreeView1.DropHighlight = TreeView1.HitTest(x, y)
   End If
End Sub


Private Sub TreeView2_DragDrop(Source As Control, x As Single, y As Single)
Dim nd As Node
On Error GoTo hell
If UCase(Source.Name) = UCase("Treeview1") Then
    If 0 = Me.TreeView2.Nodes.Count Then
        Set nd = Me.TreeView2.Nodes.Add(, , Me.TreeView1.SelectedItem.key, Me.TreeView1.SelectedItem.text, "defaultimg", "selimg")
    Else
        If Me.TreeView2.SelectedItem Is Nothing Then
            Set nd = Me.TreeView2.Nodes.Add(, , Me.TreeView1.SelectedItem.key, Me.TreeView1.SelectedItem.text, "defaultimg", "selimg")
        Else
            Set nd = Me.TreeView2.Nodes.Add(Me.TreeView2.SelectedItem.key, tvwChild, Me.TreeView1.SelectedItem.key, Me.TreeView1.SelectedItem.text, "defaultimg", "selimg")
            nd.Expanded = True
        End If
    End If
End If

hell:
Select Case Err.Number
    Case 35602
    MsgBox "Already Exist", vbInformation
End Select

End Sub

Private Sub TreeView2_NodeClick(ByVal Node As MSComctlLib.Node)
    Me.Label2.Caption = Node.text
End Sub
